*******************************************************************************
*   File........: Demo1.prg
*   Date........: May 12, 1994
*   Author......: Ly Minh Tr (CIS 73062,512)
*   Copyright...: Copyright (c) 1993, Tri M. Ly
*   Version.....: 2.02
*******************************************************************************
#DEFINE K_LEFTJUST          "L"
#DEFINE K_CENTERJUST        "C"
#DEFINE K_RIGHTJUST         "R"

#DEFINE K_NORMALSTYLE       "N"
#DEFINE K_BOLDSTYLE         "B"
#DEFINE K_ITALICSTYLE       "I"
#DEFINE K_ITALICBOLDSTYLE   "BI"

#DEFINE K_OK                "OK"
#DEFINE K_CONTINUE          "C"
#DEFINE K_OKCANCEL          "OKC"
#DEFINE K_YESNO             "YN"
#DEFINE K_YESNOCANCEL       "YNC"
#DEFINE K_RETRYCANCEL       "RC"
#DEFINE K_ABORTRETRYIGNORE  "ARI"

#DEFINE K_ICONHAND          "HAND"
#DEFINE K_ICONQUESTION      "?"
#DEFINE K_ICONEXCLAMATION   "!"
#DEFINE K_ICONASTERISK      "*"
#DEFINE K_ICONINFORMATION   "INFO"
#DEFINE K_ICONSTOP          K_ICONHAND

#DEFINE K_1LINE             CHR(13)
#DEFINE K_2LINE             K_1LINE+K_1LINE
#DEFINE K_ESC               27


PRIVATE cmsg, ctitle, ctype, cprompt, nrow, ncol, cpad, cans
PRIVATE cfont, nsize, cstyle, ccolor, nnumeric, colddemo

cans    = "Welcome"
colddemo= ""

DO WHILE .T.
    cmsg    = ""
    ctitle  = ""
    cprompt = ""
    ctype   = K_ICONINFO
    nrow    = -1
    ncol    = -1
    cpad    = K_LEFTJUST
    cfont   = "MS Sans Serif"
    nsize   = 9
    cstyle  = "B"
    ccolor  = ""
    nnumeric= 0

    IF (cans <> "Quit")
        coldans = cans
    ENDIF

    DO CASE
        CASE cans == "Welcome"
            cans = welcome()
        CASE cans == "Screen 1"
            cans = screen1()
        CASE cans == "Screen 2"
            cans = screen2()
        CASE cans == "Screen 3"
            cans = screen3()
        CASE cans == "Screen 4"
            cans = screen4()
        CASE cans == "Screen 5"
            cans = screen5()
        CASE cans == "Quit"
            cans = doquit()
            IF cans == K_OK
                EXIT
            ELSE
                cans = coldans
            ENDIF
    ENDCASE
ENDDO

RETURN


FUNCTION welcome

    cmsg    = "WMsgBox()" + K_2LINE + ;
              "The Ultimate Messaging Function" + K_1LINE + ;
              "for" + K_1LINE + ;
              "FoxPro for Windows" + K_2LINE + ;
              "by" + K_1LINE + ;
              "Ly Minh Tri" + K_1LINE + ;
              "(CIS 73062,512)"
    ctitle  = "Introduction"
    cprompt = "Screen \<1;About;\?\<Quit"
    cpad    = K_CENTERJUST
    ctype   = ""
    cfont   = "Times New Roman"
    nsize   = 16
    cstyle  = "BI"
    ccolor  = "GR+/B"
    chelp   = "Go to Screen 1;About;Quit Demo"
    cfunc   = "DO_VALID()"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp, cfunc)


FUNCTION do_valid
    IF _CUROBJ == 2
        WAIT WINDOW [This is a demonstration of the ability] + CHR(13) + ;
                    [to pass in a VALID routine to be called] + CHR(13) + ;
                    [by the VALID clause in WMsgBox()!!!]
        WAIT WINDOW [You can put a HELP button as one of] + CHR(13) + ;
                    [the options so the user may select] + CHR(13) + ;
                    [HELP to get more information on what] + CHR(13) + ;
                    [to do next or whatever is relevant!]
        RETURN 1
    ENDIF
RETURN .T.


FUNCTION screen1

    cmsg    = "Welcome to WMsgBox() Demo...." + K_2LINE + ;
              "This demo will give you a rough idea of" + K_1LINE + ;
              "the flexibility of the WMsgBox function." + K_2LINE + ;
              "WMsgBox() provides you the same features" + K_1LINE + ;
              "as Microsoft's MsgBox() function." + K_2LINE + ;
              "WMsgBox() is written completely in FPW!"
    ctitle  = "Screen 1"
    cprompt = "\<Welcome;\!Screen \<2;\?\<Quit"
    ccolor  = ""
    chelp   = "Return to Welcome Screen;Go to Screen 2;Quit Demo"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)


FUNCTION screen2

    cmsg    = "WMsgBox() gives you the option to change the font" + K_1LINE + ;
              "for the message.  WMsgBox() will automatically" + K_1LINE + ;
              "create the window to be large enough to hold all" + K_1LINE + ;
              "data in the message."
    ctitle  = "Screen 2"
    cprompt = "Screen \<1;\!Screen \<3;\?\<Quit"
    nrow    = 5
    ncol    = 5
    cfont   = "Times New Roman"
    nsize   = 12
    cstyle  = "BI"
    ccolor  = "B+/W*"
    chelp   = "Return to Screen 1;Go to Screen 3;Quit Demo"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)


FUNCTION screen3
    PRIVATE retval

    retval = "Screen 4"
    IF FILE("bitmaps.dbf")
        SELECT 0
        USE bitmaps ALIAS bitmaps
    ELSE
        WAIT WINDOW [File BITMAPS.DBF does not exists.]
    ENDIF

    cmsg    = "Do you see this message in the color RED?" + K_2LINE + ;
              "This is an example of the ability to specify" + K_1LINE + ;
              "the color scheme or color pair for your messages!"
    ctitle  = "Screen 3"
    *
    * For this one, try accessing the field name in file BITMAPS.DBF
    *
    ctype   = "QUESTION"    
    cprompt = "Screen \<2;\!Screen \<4;\?\<Quit"
    nrow    = 15
    ncol    = 35
    cpad    = K_LEFTJUST
    cfont   = WFONT(1, "COMMAND")
    nsize   = WFONT(2, "COMMAND")
    cstyle  = "BI"
    ccolor  = "R/W*"
    chelp   = "Return to Screen 2;Go to Screen 4;Quit Demo"

    retval  = wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)

    IF USED("bitmaps")
        USE
    ENDIF
RETURN retval


FUNCTION screen4
    cmsg    = "WMsgBox() also gives you the ability to" + K_1LINE + ;
              "specify LEFT, CENTER, or RIGHT justification for your" + K_1LINE + ;
              "your messages." + K_2LINE + ;
              "You can also display a message without" + K_1LINE + ;
              "buttons!  Thus, making WMsgBox() a great replacement or" + K_1LINE + ;
              "alternative to the WAIT...WINDOW command!!!" + K_1LINE + ;
              "(Please press the ESCAPE key to continue!)"
    ctitle  = "Screen 4"
    ctype   = K_ICONHAND
    cprompt = ""
    cpad    = K_RIGHTJUST

    = wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
            cpad, cfont, nsize, cstyle, ccolor, nnumeric)

    WAIT WINDOW "Please press the ESCAPE key to continue!" TIMEOUT 2
    READ MODAL ;
        VALID (LASTKEY() = K_ESC)

    cmsg    = "Please select one" + K_1LINE + ;
              "of the" + K_1LINE + ;
              "buttons below!"
    cprompt = "Screen \<3;\!Screen \<5;\?\<Quit"
    nsize   = nsize + 2
    cpad    = K_CENTERJUST
    chelp   = "Return to Screen 3;Go to Screen 5;Quit Demo"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)


FUNCTION screen5

    cmsg    = "This concludes the WMsgBox() Demo." + K_2LINE + ;
              "Notice there is no ICON associated with this" + K_1LINE + ;
              "message." + K_2LINE + ;
              "Well, I hope you will find WMsgBox() useful..." + K_1LINE + ;
              "and please let me know how you like it!!!"
    ctitle  = "Screen 5"
    ctype   = ""
    cfont   = "New Courier"
    nsize   = 12
    cprompt = "Screen \<4;\!\?\<Quit"
    chelp   = "Return to Screen 4;Quit Demo"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)


FUNCTION doquit

    cmsg    = "This will end your WMsgBox() Demo."
    ctitle  = "Quit Demo"
    ctype   = K_ICONINFORMATION
    cprompt = "OKc"
    nrow    = -1
    ncol    = -1
    cpad    = K_LEFTJUST
    cfont   = "MS Sans Serif"
    nsize   = 9
    cstyle  = "B"
    ccolor  = ""
    nnumeric= 0
    chelp   = "Confirm Quit;Return to last demo screen"

RETURN wmsgbox(cmsg, ctitle, ctype, cprompt, nrow, ncol, ;
               cpad, cfont, nsize, cstyle, ccolor, nnumeric, chelp)
